//Target vehicle info
//Created by: PlagueDog

//Echo target info?
$EchoTargetInfo = false;
$Client_Target = "-1";
$Client_Target_ID = "-1";

function TargetInfoTicker()
{
	if(!IsObject(MissionGroup))
	{
		if(IsObject(Ghostgroup))
		{
			if(IsObject(GetNextObject(Squad,0)))
			{
			$Client_Target = GetTargetId(GetNextObject(Squad,0));
				if(IsObject($Client_Target == true))
				{
					if($Client_Target != $Client_Target_ID)
					{
						$Client_Target_ID = $Client_Target;
						GrabWeaponData();
						GrabInternalMountData();
					}
				}
			}
		}
		else if(IsObject($Client_Target) == false)
		{
		TextList::Clear(Weapon_Info);
		TextList::Clear(Internal_Info);
		$Client_Target_ID = "-1";
		}
	}
	//Loop this function so we don't interrupt other hud scripts such as Rearview.
	Schedule("TargetInfoTicker();", 1);
}

function GrabWeaponData()
{
TextList::Clear(Weapon_Info);
%Target_WeaponCount = GetWeaponCount($Client_Target);
	if(IsObject($Client_Target))
	{
		for(%W = 0; %W != %Target_WeaponCount; %W++)
		{
			%WeapID = GetWeaponID($Client_Target, %W);
			if(%WeapID != -1)
			{
				for(%FindWeapID = 0; %FindWeapID <= %WeapID; %FindWeapID++)
				{
					if(%FindWeapID == %WeapID)
					{
						echo($WeaponName[%FindWeapID]);
						$TarWeap[%W] = $WeaponName[%FindWeapID];
						//$TargetWeapons = $TargetWeapons @ $TarWeap[%W]@"\n";
						TextList::AddLine(Weapon_Info, $TarWeap[%W]);
					}
				}
			}
		}
	}
}

function GrabInternalMountData()
{
TextList::Clear(Internal_Info);
	if(IsObject($Client_Target))
	{
		for(%I = 0; %I != 10; %I++)
		{
			GrabVehicleData();
			%IntMountID = GetComponentID("VehicleData", %I);
			for(%FindIntMountID = 0; %FindIntMountID <= %IntMountID; %FindIntMountID++)
			{
				if((%IntMountID >= 810) || ((%IntMountID >= 300) && (%IntMountID <= 333)))
				{
					if(%FindIntMountID == %IntMountID)
					{
					echo($ComponentName[%FindIntMountID]);
					$TarComponent[%I] = $ComponentName[%FindIntMountID];
					//$TargetComponents = $TargetComponents @ $TarComponent[%I]@"\n";
					TextList::AddLine(Internal_Info, $TarComponent[%I]);
					}
				}
			}
			focusclient();
			DeleteServer();
		}
	}
}

function GrabVehicleData()
{
storeobject($Client_Target, "VehicleData");
newserver();focusserver();
LoadObject(VehicleData, "VehicleData");
SetPosition(VehicleData,0,0,-999999);
}

TargetInfoTicker();

//Weapon ID Arrays
$WeaponName[1]="NIKE";
$WeaponName[2]="AML";
$WeaponName[3]="DISR";
$WeaponName[5]="PROB";
$WeaponName[6]="TURRET-HLAS";
$WeaponName[7]="TURRET-VIP";
$WeaponName[8]="TUR-INT-HLAS";
$WeaponName[9]="TURRET-CAN";
$WeaponName[12]="TURRET-ART";
$WeaponName[13]="PBW";
$WeaponName[14]="TURRET-HATC";
$WeaponName[15]="TURRET-MFAC";
$WeaponName[101]="LAS";
$WeaponName[102]="HLAS";
$WeaponName[103]="TLAS";
$WeaponName[105]="EMP";
$WeaponName[106]="ELF";
$WeaponName[107]="BLAS";
$WeaponName[108]="HBLAS";
$WeaponName[109]="PBW";
$WeaponName[110]="PLAS";
$WeaponName[111]="BLNK";
$WeaponName[112]="QGUN`";
$WeaponName[113]="MFAC";
$WeaponName[114]="NANO";
$WeaponName[115]="NCAN";
$WeaponName[116]="ATC";
$WeaponName[117]="HATC";
$WeaponName[118]="EMC";
$WeaponName[119]="BC";
$WeaponName[120]="HBC";
$WeaponName[121]="RAIL";
$WeaponName[124]="VIP8";
$WeaponName[125]="VIP12";
$WeaponName[126]="SPR6";
$WeaponName[127]="SPR10";
$WeaponName[128]="SWRM";
$WeaponName[129]="MIN";
$WeaponName[130]="SHRK";
$WeaponName[147]="APHID";
$WeaponName[131]="ARA6";
$WeaponName[132]="ARA10";
$WeaponName[133]="ARA14";
$WeaponName[134]="PRX6";
$WeaponName[135]="PRX8";
$WeaponName[136]="PRX10";
$WeaponName[142]="RAD";
$WeaponName[150]="SGUN";

//Component ID Arrays
//Engines
$ComponentName[100]="Light Engine";
$ComponentName[101]="Light High Output Engine";
$ComponentName[102]="Light Agility Engine";
$ComponentName[103]="Standard Medium Engine";
$ComponentName[104]="Medium High Output Engine";
$ComponentName[105]="Medium Agility Engine";
$ComponentName[106]="Standard Heavy Engine";
$ComponentName[107]="Improved Heavy Engine";
$ComponentName[108]="Heavy Cruise Engine";
$ComponentName[109]="Heavy High Output Engine";
$ComponentName[110]="Heavy Agility Engine";
$ComponentName[111]="Standard Assault Engine";
$ComponentName[112]="Improved Assault Engine";
$ComponentName[113]="Heavy Turbine Engine";
$ComponentName[114]="High Output Turbine Engine";
$ComponentName[115]="Super Heavy Engine";
$ComponentName[128]="Alpha Light Vehicle Engine";
$ComponentName[129]="BetaLight Agility Engine";
$ComponentName[130]="Gamma Standard Medium Engine";
$ComponentName[131]="Delta Medium Cruise Engine";
$ComponentName[132]="Epsilon Improved Medium Engine";
$ComponentName[133]="Zeta Medium High Output Engine";
$ComponentName[134]="Eta Medium Agility Engine";
$ComponentName[135]="Theta Standard Heavy Engine";
$ComponentName[136]="Iota Heavy High Output Engine";
$ComponentName[137]="Kappa Heavy Agility Engine";
$ComponentName[138]="Lamda Standard Assault Engine";
$ComponentName[139]="Mu Improved Assault Engine";
$ComponentName[140]="Nu High Output Engine";
$ComponentName[141]="Xi Heavy Assault Engine";
$ComponentName[142]="Omicron Heavy Assault Turbine";
$ComponentName[143]="Pi Super Heavy Turbine";
//Reactors
$ComponentName[200]="Micro Reactor";
$ComponentName[201]="Small Reactor";
$ComponentName[202]="Standard Reactor";
$ComponentName[203]="Medium Reactor";
$ComponentName[204]="Large Reactor";
$ComponentName[205]="Maxim Reactor";
$ComponentName[225]="Alpha Reactor";
$ComponentName[226]="Beta Reactor";
$ComponentName[227]="Gamma Reactor";
$ComponentName[228]="Delta Reactor";
$ComponentName[229]="Epsilon Reactor";
$ComponentName[230]="Zeta Reactor";
//Computers
$ComponentName[800]="Basic Computer Suite";
$ComponentName[801]="Improved Computer Suite";
$ComponentName[802]="Advanced Computer Suite";
$ComponentName[805]="Cybrid Basic System Control";
$ComponentName[806]="Cybrid Enhanced System Control";
$ComponentName[807]="Cybrid Adv. System Control";
//Shields
$ComponentName[300]="Standard Shield Generator";
$ComponentName[301]="Protector Shield Generator";
$ComponentName[302]="Guardian Shield Generator";
$ComponentName[303]="FastCharge Shield Generator";
$ComponentName[304]="Centurion Shield Generator";
$ComponentName[305]="Repulsor Shield Generator";
$ComponentName[306]="Titan Shield Generator";
$ComponentName[307]="Medusa Shield Generator";
$ComponentName[326]="Alpha Shield Generator";
$ComponentName[327]="Beta Shield Generator";
$ComponentName[328]="Gamma Shield Generator";
$ComponentName[329]="Delta Shield Generator";
$ComponentName[330]="Epsilon shield Generator";
$ComponentName[331]="Zeta Shield Generator";
$ComponentName[332]="Eta Shield Generator";
$ComponentName[333]="Theta Shield Generator";
//Armor
$ComponentName[926]="Carbon Fiber Laminate Armor";
$ComponentName[927]="Quad-Bonded MetaPlas Armor";
$ComponentName[928]="Depleted Uranium Carapace";
$ComponentName[929]="Ceramic Armor";
$ComponentName[930]="Crystaluminum Armor";
$ComponentName[931]="Quicksilver Nano-Armor";
//Sensors
$ComponentName[400]="Basic Sensor";
$ComponentName[401]="Ranger Sensor";
$ComponentName[408]="Standard Sensor";
$ComponentName[409]="Longbow Sensor";
$ComponentName[410]="Infiltrator Sensor";
$ComponentName[411]="Crossbow Sensor";
$ComponentName[412]="Ultralight Sensor";
$ComponentName[413]="Bloodhound Sensor";
$ComponentName[414]="Emission Scanning Sensor";
$ComponentName[426]="Cybrid Basic Sensor";
$ComponentName[427]="Cybrid Enhanced Range Sensor";
$ComponentName[428]="Cybrid Intermediate Sensor";
$ComponentName[429]="Cybrid Long-Range Sensor";
$ComponentName[430]="Cybrid Enhanced Passive Sensor";
$ComponentName[431]="Cybrid Extended Range Sensor";
$ComponentName[432]="Cybrid Compact Sensor";
$ComponentName[433]="Cybrid Enhanced Tracker Sensor";
$ComponentName[434]="Cybrid Motion Sensor";
//Specials
$ComponentName[810]="Guardian ECM Jammer";
$ComponentName[811]="Doppleganger ECM Jammer";
$ComponentName[812]="Cybrid Alpha ECM Jammer";
$ComponentName[813]="Cybrid Beta ECM Jammer";
$ComponentName[820]="Thermal Diffusion Jammer";
$ComponentName[830]="Chameleon Cloak";
$ComponentName[831]="Cuttlefish Cloak";
$ComponentName[840]="Shield Modulator";
$ComponentName[845]="Shield Capacitor";
$ComponentName[850]="Shield Amplifier";
$ComponentName[860]="Laser Target Designator";
$ComponentName[865]="Auxiliary Power Storage";
$ComponentName[870]="Energy Capacitor";
$ComponentName[875]="Field Stablizer";
$ComponentName[880]="Rocket Booster";
$ComponentName[885]="Turbine Booster";
$ComponentName[890]="Nano-Repair Module";
$ComponentName[900]="Angel Life Support System";
$ComponentName[910]="Alien Anti-Gravity Module";
$ComponentName[912]="Electrohull";
$ComponentName[914]="Universal Ammo Pack";